﻿using System;
using System.Xml;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Lab6.Persistence;
using MiniLib.Model;
using MiniLib.Persistence;

namespace Lab6.Model
{
    public partial class Biblioteca : DocumentBase
    {
        public class BibliotecaManager : DocumentBase.DocumentManagerBase
        {
            private Logger _Logger;

            public BibliotecaManager(BibliotecaPersister persister)
                : base(persister)
            {
            }

            public Biblioteca Biblioteca
            {
                get { return (base.Document as Biblioteca); }
            }

            public override void NewDocument()
            {
                //OpenLog(new Logger("../../LogFile.xml"));
                base.NewDocument();
            }

            public override void OpenDocument()
            {
                //OpenLog(new Logger("../../LogFile.xml"));
                base.OpenDocument();
            }

            public override void CloseDocument()
            {
                base.CloseDocument();
                //CloseLog();
            }

            public void AggiungiLibro(Libro libro)
            {
                bool isOk = Biblioteca.Aggiungi(libro);
                if (_Logger != null)
                    _Logger.TracciaNuovoLibro(libro, isOk);
            }

            public void ModificaLibro(Libro libro)
            {
                bool isOk = Biblioteca.Modifica(libro);
                if (_Logger != null)
                    _Logger.TracciaModificaLibro(libro, isOk);
            }

            public void AggiungiPersona(Persona persona)
            {
                bool isOk = Biblioteca.Aggiungi(persona);
                if (_Logger != null)
                    _Logger.TracciaNuovaPersona(persona, isOk);
            }

            public void ModificaPersona(Persona persona)
            {
                bool isOk = Biblioteca.Modifica(persona);
                if (_Logger != null)
                    _Logger.TracciaModificaPersona(persona, isOk);
            }

            public void AggiungiPrestito(Prestito prestito)
            {
                bool isOk = Biblioteca.Aggiungi(prestito);
                if (_Logger != null)
                    _Logger.TracciaNuovoPrestito(prestito, isOk);
            }

            public void RimuoviPrestito(Prestito prestito)
            {
                bool isOk = Biblioteca.Rimuovi(prestito);
                if (_Logger != null)
                    _Logger.TracciaCancellazionePrestito(prestito, isOk);
            }

            protected override string DefaultName
            {
                get { return "Biblioteca"; }
            }

            protected override DocumentBase CreateDocument(string name)
            {
                return new Biblioteca(name);
            }

            private void OpenLog(Logger logger)
            {
                if (logger == null)
                    throw new ArgumentNullException("logger");
                _Logger = logger;
            }

            private void CloseLog()
            {
                if (_Logger != null)
                {
                    _Logger.Close();
                    _Logger = null;
                }
            }
        }
    }
}
